#if defined(__XC)
#include <xc.h>         /* XC8 General Include File */
#elif defined(HI_TECH_C)
#include <htc.h>        /* HiTech General Include File */
#endif

#include "user.h"
#include "SIRC.h"


void SendOne_SIRC()
{
	TMR0 = PER_600;
	INTCONbits.TMR0IF = 0;
	PWM1CONbits.PWM1EN = 1;
	while (!INTCONbits.TMR0IF);
	TMR0 = PER_600;
	INTCONbits.TMR0IF = 0;
	PWM1CONbits.PWM1EN = 1;
	while (!INTCONbits.TMR0IF);
	TMR0 = PER_600;
	INTCONbits.TMR0IF = 0;
	PWM1CONbits.PWM1EN = 0;
	while (!INTCONbits.TMR0IF);
}

void SendZero_SIRC()
{
	TMR0 = PER_600;
	INTCONbits.TMR0IF = 0;
	PWM1CONbits.PWM1EN = 1;
	while (!INTCONbits.TMR0IF);
	TMR0 = PER_600;
	INTCONbits.TMR0IF = 0;
	PWM1CONbits.PWM1EN = 0;
	while (!INTCONbits.TMR0IF);
}

void SendStart_SIRC()
{
	TMR0 = PER_600;
	INTCONbits.TMR0IF = 0;
	PWM1CONbits.PWM1EN = 1;
	while (!INTCONbits.TMR0IF);
	TMR0 = PER_600;
	INTCONbits.TMR0IF = 0;
	PWM1CONbits.PWM1EN = 1;
	while (!INTCONbits.TMR0IF);
	TMR0 = PER_600;
	INTCONbits.TMR0IF = 0;
	PWM1CONbits.PWM1EN = 1;
	while (!INTCONbits.TMR0IF);
	TMR0 = PER_600;
	INTCONbits.TMR0IF = 0;
	PWM1CONbits.PWM1EN = 1;
	while (!INTCONbits.TMR0IF);
	TMR0 = PER_600;
	INTCONbits.TMR0IF = 0;
	PWM1CONbits.PWM1EN = 0;
	while (!INTCONbits.TMR0IF);
}

void SendCommand_SIRC(unsigned char device, unsigned char cmd)
{
	unsigned char i;
	SendStart_SIRC();
	for (i = 0; i < 7; i++) {
		if (cmd & 0x01)
			SendOne_SIRC();
		else
			SendZero_SIRC();
		cmd >>= 1;
	}
	for (i = 0; i < 5; i++) {
		if (device & 0x01)
			SendOne_SIRC();
		else
			SendZero_SIRC();
		device >>= 1;
	}
}

void ReadCommand_SIRC(void)
{

	unsigned char i;
	unsigned int data = 0;
	/* DETECT FALLING EDGE */
	IOCAPbits.IOCAP2 = 0;
	IOCANbits.IOCAN2 = 1;
	while (!IOCAFbits.IOCAF2);
	IOCAFbits.IOCAF2 = 0;

	/* Load 2500us */
	TMR0 = PER_2500;
	INTCONbits.TMR0IF = 0;
	while (!INTCONbits.TMR0IF && !IOCAFbits.IOCAF2);
	if (IOCAFbits.IOCAF2)
		return;

	for (i = 0; i < 12; i++) {

		/* Start 1200us timer */
		INTCONbits.TMR0IF = 0;
		IOCAFbits.IOCAF2 = 0;
		TMR0 = PER_1200;
		while (!IOCAFbits.IOCAF2 && !INTCONbits.TMR0IF);
		if (INTCONbits.TMR0IF)
			return;
		INTCONbits.TMR0IF = 0;
		IOCAFbits.IOCAF2 = 0;
		TMR0 = PER_900;
		while (!IOCAFbits.IOCAF2 && !INTCONbits.TMR0IF);
		if (IOCAFbits.IOCAF2)
			return;
		data |= !PORTAbits.RA2;
		if (i != 11)
			data <<= 1;
	}
	for (i = 0; i < 4; i++) {
		TMR0 = PER_2500;
		INTCONbits.TMR0IF = 0;
		while (!INTCONbits.TMR0IF && !IOCAFbits.IOCAF2);
		if (IOCAFbits.IOCAF2)
			return;
	}
	VALUE = data;
	IS_READ = 0;
}
