/******************************************************************************/
/* User Level #define Macros                                                  */
/******************************************************************************/
#define START_C	0b00001000	//START CONDITION MASK
#define STOP_C	0b00010000	//STOP CONDITION MASK
#define STATE1	0b00001001	// MASTER WRITE LAST WAS ADDRESS
#define STATE2	0b00101001	// MASTER WRITE LAST WAS DATA
#define STATE3	0b00001101	// MASTER READ LAST WAS ADDRESS
#define STATE4	0b00101100	// MASTER READ LAST WAS DATA
#define STATE5	0b00100000	// MASTER NACK


#define SCL_TRIS		TRISCbits.TRISC0
#define SCL_LAT			LATCbits.LATC0
#define SCL_PORT		PORTCbits.RC0
#define SDA_TRIS		TRISCbits.TRISC1
#define SDA_LAT			LATCbits.LATC1
#define SDA_PORT		PORTCbits.RC1

#define ADDR_TRIS		TRISCbits.TRISC4
#define ADDR_LAT		LATCbits.LATC4
#define ADDR_PORT		PORTCbits.RC4

#define DEFAULT_ADDRESS		0x24
#define MEMORY_ADDRESS		0x7FF

#define MAX_BUFFER_SIZE		10

#define RC5			0
#define SIRC			1


/******************************************************************************/
/* User Function Prototypes                                                   */
/******************************************************************************/

void InitApp(void);         /* I/O and Peripheral Initialization */

unsigned int ReadFlash(unsigned int address);
void EraseFlash(unsigned int address);
void UnlockFlash(void);
void WriteFlash(unsigned int data, unsigned int address);
void Delay(unsigned int delay);
void SetAddress(unsigned char addr);


void InitInterrupt(void);
void InitAddress(void);
void InitGPIO(void);
void InitPWM(void);
void InitTimer0(void);
void InitI2C(void);
void InitApp(void);

/******************************************************************************/
/* Global Variables	                                                      */
/******************************************************************************/
extern unsigned char DATA_BUFFER[6];
extern unsigned int DATA_OUT[2];
extern unsigned char DATA_INDEX;
extern unsigned char ADDRESS;
extern unsigned char MODE;
extern unsigned char IS_READ;
extern unsigned int VALUE;




